<?php
namespace Teknisa\Model\Integracao\Repositories;
use Doctrine\DBAL\Connection;

class Layoutexp extends \Doctrine\ORM\EntityRepository {
    
    public function getTables($layoutId, $startPos, $finalPos, $filters){
        $query = <<<SQL
        SELECT *
          FROM (
            SELECT T.*, RowNum rn
              FROM (
                SELECT NMTABELABD AS NAME,
                       DSTABELABD AS DESCRIPTION,
                       IDATIVO AS ACTIVE
                 FROM  TABELA
                WHERE  IDATIVO = 'S'
                       AND NMTABELABD NOT IN (SELECT NMTABELABD
                                                FROM TABLAYOUTEXP
                                               WHERE CDLAYOUTEXP = :layoutId)
             ORDER BY NMTABELABD ASC) T
            WHERE RowNum <= :finalPos
            $filters)
         WHERE rn >= :startPos
SQL;
        $params = array(
            'layoutId' => $layoutId,
            'startPos' => $startPos,
            'finalPos' => $finalPos
        );
        
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
    public function getLayoutExportation($conditions){
        $query = <<<SQL
		SELECT *
		FROM(
		    SELECT  NMLAYOUTEXP AS NAME,
		            CDLAYOUTEXP AS ID,
		            CDLAYOUTEXP AS LAYOUT_ID,
		            IDATIVO AS ACTIVE
		    FROM    LAYOUTEXP)
		WHERE   1=1
		$conditions
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }
    
}